<template>
  <q-page class="row justify-center bg-blue-grey-1 q-pa-xl">
    <dialog-stepper
      v-model="composing"
      :vuelidate="$v.composing"
      :show-dialog="showDialog"
      @hide-dialog="showDialog = false"
    />

    <tooltip-info
      :info="info"
      @info="info = null"
    />

    <composition-view
      v-if="composingId"
      :composing="composing"
      @info="setInfo"
    />

    <editor-tiptap
      v-if="!composingId"
      v-model="composing"
    />

    <json-pretty
      v-if="composing.doc && $store.state.session.QUASAR_ENV === 'development'"
      :text="composing.doc"
      class="col"
    />
  </q-page>
</template>

<script>
import DialogStepper from '../../components/composing/dialog-stepper'
import CompositionView from 'components/composing/composition-view'
import EditorTiptap from '../../components/composing/editor-tiptap'
import DialogRating from '../../components/composing/dialog-rating'
import TooltipInfo from 'components/composing/tooltip-info'
import JsonPretty from '../../components/core/json-pretty'
import { required } from 'vuelidate/lib/validators'
import { colors } from 'quasar'
import _ from 'lodash'

const { hexToRgb } = colors

const factoryComposing = JSON.stringify({
  title: null,
  status: 'Rascunho',
  doc: null,
  topicId: null,
  comments: {},
  usuariosId: null
})

export default {
  name: 'PageComposing',
  components: {
    CompositionView,
    DialogStepper,
    EditorTiptap,
    TooltipInfo,
    JsonPretty
  },
  props: {
    submit: {
      type: Boolean,
      required: true
    },
    rating: {
      type: Boolean,
      required: true
    }
  },
  asyncData: {
    composingDefault: {},
    async composing () {
      if (!this.composingId) {
        this.showDialog = true
        this.$emit('rating', {})

        return JSON.parse(factoryComposing)
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: `/Compositions/${this.composingId}`,
          params: {
            filter: {
              fields: ['id', 'title', 'status', 'doc', 'topicId', 'comments', 'rating']
            }
          }
        }

        const Response = await this.$axios(axiosConfig).then(R => R.data)
        const { status, rating } = Response || {}

        this.$emit('topic', Response.topicId)
        this.$emit('rating', { status, rating })

        return Response
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    },
    categoriesDefault: [],
    async categories () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Categories',
          params: {
            filter: {
              fields: ['id', 'label', 'color'],
              where: { type: 'rating' }
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      showDialog: false,
      info: null
    }
  },
  validations: {
    composing: {
      status: {
        required
      },
      doc: {
        required
      },
      topicId: {
        required
      }
    }
  },
  computed: {
    composingId () {
      return Number(this.$route.params.id)
    }
  },
  watch: {
    'composing.topicId' (topicId) {
      if (!this.composingId) {
        this.$emit('topic', topicId)
      }
    },
    submit (submit) {
      if (submit) {
        this.save()
      }
    },
    rating (rating) {
      if (rating) {
        this.$q.dialog({
          info: this.composing.rating,
          component: DialogRating,
          parent: this
        }).onDismiss(() => {
          this.$emit('rated')
        })
      }
    }
  },
  mounted () {
    switch (this.composingId) {
      case 0:
        this.$emit('submit', false)
        break

      default:
        this.$emit('submit', true)
        break
    }
  },
  methods: {
    async save () {
      this.$v.composing.$touch()

      if (this.$v.composing.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'POST',
          url: '/Compositions',
          data: JSON.parse(JSON.stringify(this.composing))
        }

        axiosConfig.data.status = 'Enviado'
        axiosConfig.data.usuariosId = this.$store.state.session.user.id

        await this.$axios(axiosConfig)

        this.$emit('reload')
        this.axiosSuccess('Redação enviada com sucesso', '/compositions')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }
    },
    hex2rgb (hexColor) {
      try {
        const { r, g, b } = hexToRgb(hexColor)
        return `rgb(${r}, ${g}, ${b})`
      } catch (e) {
        return hexColor
      }
    },
    setInfo (key) {
      const commentId = Object.keys(this.composing.comments).find((comment) => {
        try {
          const [tempSelected, tempColor] = this.composing.comments[comment].id.split('_')
          const tempBackgroundColor = this.hex2rgb(tempColor).replace(/\D/g, '')
          const tempId = `${tempSelected}_${tempBackgroundColor}`

          return tempId === key
        } catch (e) {
          return comment === key
        }
      })

      const [selected, backgroundColor] = `${key}_`.split('_')
      const _backgroundColor = backgroundColor ? `_${backgroundColor.replace(/\D/g, '')}` : ''
      const target = `#${_.snakeCase(selected) + _backgroundColor}`
      const { comment, categoryId } = this.composing.comments[commentId] || {}
      const { color, label } = this.categories.find(({ id }) => id === categoryId) || {}

      this.info = { target, color, label, comment }
    }
  }
}
</script>
